Index: /smplayer/trunk/build_os2.cmd
===================================================================
--- /smplayer/trunk/build_os2.cmd	(revision 109)
+++ /smplayer/trunk/build_os2.cmd	(revision 110)
@@ -10,10 +10,12 @@
 /* version 0.2.6 from 29.01.2010 Silvan (added more readmes) */
 /* version 0.2.7 from 29.04.2010 Silvan (added smplayer version for sed'ing readme's */
+/* version 0.2.8 from 20.05.2010 Silvan (added version to zip) */
 
 /* init the version string (don't forget to change) */
-version = "0.2.7"
-version_date = "29.04.2010"
+version = "0.2.8"
+version_date = "20.05.2010"
 smplayer_version = "0.6.9"
 smplayer_build = "beta1"
+internal_build = "0_6_9-b2"
 '@echo off'
 
@@ -134,5 +136,6 @@
 /* zip all up */
 	ok = directory(installDir)
-	address cmd 'zip -r smplayer.zip *'
+	cmdtorun = 'zip -r smplayer-' || internal_build || '.zip *'
+	address cmd cmdtorun
 	ok = directory(rootdir)
     end
Index: /smplayer/trunk/liesmich.os2
===================================================================
--- /smplayer/trunk/liesmich.os2	(revision 109)
+++ /smplayer/trunk/liesmich.os2	(revision 110)
@@ -93,7 +93,6 @@
 * Qt4 dll
 
-    ftp://ftp.netlabs.org/pub/qt4/qt-lib-4_5_1-xx.wpi (ersetzen Sie xx mit der aktuellsten version)
-    falls die GA verfgbar ist, befindet sie sich im Unterverzeichniss 4.5.1-ga.
-
+    unter http://svn.netlabs.org/qt4 finden Sie die ntigen Angaben wo Sie Qt4 bekommen und wie man es installiert
+ 
 * MPlayer
 
@@ -271,4 +270,7 @@
 =========================
 
+2010-06-30
+  * fixed a nasty 1 second delay
+
 2010-04-29
   * updated to Qt4 4.6.2
Index: /smplayer/trunk/lisezmoi.os2
===================================================================
--- /smplayer/trunk/lisezmoi.os2	(revision 109)
+++ /smplayer/trunk/lisezmoi.os2	(revision 110)
@@ -113,6 +113,5 @@
 * Qt4 dll
 
-    ftp://ftp.netlabs.org/pub/qt4/qt-lib-4_5_1-xx.wpi (exchange xx with the most current available)
-    if GA is available it's in it's own subdir 4.5.1-ga
+    see http://svn.netlabs.org/qt4 for more information whats needed
 
 * MPlayer
@@ -310,4 +309,7 @@
 ==========================
 
+2010-06-30
+  * fixed a nasty 1 second delay
+
 2010-04-29
   * updated to Qt4 4.6.2
Index: /smplayer/trunk/readme.os2
===================================================================
--- /smplayer/trunk/readme.os2	(revision 109)
+++ /smplayer/trunk/readme.os2	(revision 110)
@@ -80,6 +80,5 @@
 * Qt4 dll
 
-    ftp://ftp.netlabs.org/pub/qt4/qt-lib-4_5_1-xx.wpi (exchange xx with the most current available)
-    if GA is available it's in it's own subdir 4.5.1-ga
+    see http://svn.netlabs.org/qt4 for more information whats needed
 
 * MPlayer
@@ -261,4 +260,7 @@
 ==========
 
+2010-06-30
+  * fixed a nasty 1 second delay
+
 2010-04-29
   * updated to Qt4 4.6.2
Index: /smplayer/trunk/src/mplayerprocess.cpp
===================================================================
--- /smplayer/trunk/src/mplayerprocess.cpp	(revision 109)
+++ /smplayer/trunk/src/mplayerprocess.cpp	(revision 110)
@@ -129,13 +129,18 @@
           return;
 
-// as things could hang when pipe communication is done direct here, i do a seperate thread for it */
+// as things could hang when pipe communication is done direct here, i do a seperate thread for it
     pipeThread = new PipeThread(text, hpipe);
     
     pipeThread->start();
     while (!pipeThread->isRunning() && !pipeThread->isFinished()) {
-       qDebug("we spleep");
+       qDebug("we sleep");
        DosSleep(10);
     }
-    if (!pipeThread->wait(2000)) {
+// we wait for max 2 seconds for the thread to be ended (we to this with max 20 loops)
+    int count = 0;
+    while (!pipeThread->wait(100) && count < 20) {
+       count ++;
+    }
+    if (count >= 20) {
        pipeThread->terminate();
        qDebug("pipe communication terminated");
@@ -889,5 +894,5 @@
        return;
 
-    qDebug("pipe connected");    
+//    qDebug("pipe connected");    
     DosWrite( hpipe, text.data(), strlen( text.data() ), &cbActual );
 
Index: /smplayer/trunk/src/svn_revision.h
===================================================================
--- /smplayer/trunk/src/svn_revision.h	(revision 109)
+++ /smplayer/trunk/src/svn_revision.h	(revision 110)
@@ -1,1 +1,1 @@
-#define SVN_REVISION "SVN-rUNKNOWN"
+#define SVN_REVISION "SVN-r92"